/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.velocity.runtime.parser.node;

import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.TemplateInitException;
import org.apache.velocity.runtime.parser.Parser;

public class ASTDirectiveAssign extends SimpleNode
{

  public ASTDirectiveAssign(int i)
  {
    super(i);
  }

  public ASTDirectiveAssign(Parser p, int i)
  {
    super(p, i);
  }

  /**
   * @throws TemplateInitException
   * @see org.apache.velocity.runtime.parser.node.Node#init(org.apache.velocity.context.InternalContextAdapter, java.lang.Object)
   */
  public Object init( InternalContextAdapter context, Object data) throws TemplateInitException
  {
  	Object obj = super.init(context, data);
  	saveTokenImages();
  	cleanupParserAndTokens(); // drop reference to Parser and all JavaCC Tokens
  	return obj;
  }


}
